
-- Heavily inspired by DKPMon / Bidder / Morgdkp

RootsBidder = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceComm-2.0","AceEvent-2.0","CandyBar-2.0","FuBarPlugin-2.0")
local AceOO = AceLibrary("AceOO-2.0")
local tablet = AceLibrary("Tablet-2.0")


RootsBidder:RegisterDB("RootsBidderDB")
RootsBidder:RegisterDefaults("account", {
    Coord_Xframe = 250,
    Coord_Yframe = 250,
    MainName= UnitName("player"),
    DKP={},
    Characters={},
} )

local options = {
	type='group',
	args = {
        Main = {
			type = 'group',
			name = 'Name of your main',
			desc = 'Set the char you earn DKP under here',
			usage = "<Your message here>",
			args={
            },
		},
		GUI= {
			type = 'execute',
			name = 'Show The frame',
			desc = "Show the frame so you can move it to where you want",
			func = "showGUI"
		},
        SHOW= {
            type = 'group',
            name = 'Show Value On Fubar',
            desc = "Select which value to show on your Fubar",
            args ={
            },
        },
	}
}


RootsBidder.GUI= {}

RootsBidder.bids= {}
RootsBidder.mbid=0
RootsBidder.biddingopen = false
RootsBidder.version = 2.1
RootsBidder.bidscounter = 0
RootsBidder.hasIcon = "Interface\\AddOns\\RootsBidder\\svindler"
RootsBidder:RegisterChatCommand({"/Rootsbider", "/rbid", "/rb"}, options)
RootsBidder.OnMenuRequest = options
local BiddingPaused = false
RootsBidder.LootList= {}

function RootsBidder:OnTextUpdate()
    if self.db.account.DKP[self.db.account.displayOnFubar] ~= nil then 
        self:SetText(self.db.account.displayOnFubar.." :".. self.db.account.DKP[self.db.account.displayOnFubar])
    end
end

function RootsBidder:OnTooltipUpdate()
    local cat = tablet:AddCategory(
        'columns', 2
    )
    cat:AddLine(
        'text', "Main :",
        'text2', self.db.account.MainName
    )
    for DKP in pairs(self.db.account.DKP) do
        cat:AddLine(
            'text',DKP.. " :",
            'text2', self.db.account.DKP[DKP]
        )
    end
end

function RootsBidder:DoOpenBid(itemid,minbid,line,link,pool)
    local item = {}
    item.id=itemid
    local itemname ,iString, iquality ,_,_,_,_,_,iTexture = GetItemInfo(itemid)
    item.name=itemname
    item.min=tonumber(minbid)
    item.line = tonumber(line)
    item.pool=pool
    item.link = link
    item.bids={}
    item.bidcount=0
    self.LootList[line]=item
    RootsBidder:InitBidLine(line)
    self.GUI.frame:SetHeight(40+(line)*25)
    RootsBidder:showGUI()
    RootsBidder.GUI.title:SetText("Bidding Started.")
    self:SetCandyBarTime("BidTimer"..line,60) 
end


function RootsBidder:AcceptBid( player, bid, maxbid,line)
	local tempbid = {}
	tempbid.player = player
	tempbid.bid = tonumber(bid)
	tempbid.max = tonumber(maxbid)
	table.insert(self.LootList[line].bids,tempbid)
    self.LootList[line].bidcount=self.LootList[line].bidcount+1
	RootsBidder:InitBidLine(line)
    self:SetCandyBarTime("BidTimer"..line,20) 
end

function RootsBidder:cancelBid()
    if RootsBidder.biddingopen then
        if self.db.account.MainName == RootsBidder.bids[1].player then
            RootsBidder:SendMessage("cancel",self.db.account.MainName)
        end
    end
end

function RootsBidder:PlaceBid(line, bid)
    if self.LootList[line].bids[1]== nil then 
        RootsBidder:SendMessage("PB",self.db.account.MainName,self.LootList[line].min,line,self.LootList[line].pool)
    else 
        RootsBidder:SendMessage("PB",self.db.account.MainName,self.LootList[line].bids[self.LootList[line].bidcount].bid + bid,line,self.LootList[line].pool)
    end
end

function RootsBidder:PassBid(line)
    self.GUI.bids[line].BidButton:Hide()
    self.GUI.bids[line].PassButton:Hide()
    self.GUI.bids[line].NeedButton:Hide()
end

function RootsBidder:doCancelBid()
	table.remove(RootsBidder.bids,1)
	for counter in pairs(RootsBidder.bids) do
		RootsBidder:UpdateBidLine(counter)
	end
end

function RootsBidder:doCloseBid(line)
    self.GUI.bids[line].BidButton:Hide()
    self.GUI.bids[line].PassButton:Hide()
    self.GUI.bids[line].NeedButton:Hide()
end

function RootsBidder:sendVersion()
    RootsBidder:SendMessage( "SendVers", UnitName("player"), RootsBidder.version )
end

function RootsBidder:ReceiveDKP(player,dkp,pool)
    if player == UnitName("player") or player == self.db.account.MainName then
        if self.db.account.DKP[pool] == nil then 
            self.db.account.DKP[pool]={}
        end
        self.db.account.DKP[pool] = dkp
        self:UpdateOptionsDKP()
        self:UpdateText()
    end
end

function RootsBidder:OnClick()
    RootsBidder:SendMessage("RD",UnitName("player"))
end

function RootsBidder:OnInitialize()
    self.BidderPrefix="<RootsBidder>"
    self.TrackerPrefix="<RootsTracker>"
    self.CommPrefix = self.BidderPrefix
end


function RootsBidder:OnEnable()
    self:Print("Enabled")
    self:SetCommPrefix(self.CommPrefix)
    self:RegisterComm(self.TrackerPrefix, "GROUP")
    self:SetIcon("Interface\\AddOns\\RootsBidder\\svindler")
    self:UpdateOptionsDKP()
    self:UpdateMain()
    if self.db.account.Characters[UnitName("player")]  == nil then
        local char = {}
        char.name = UnitName("player")
        char.class=UnitClass("player")
        char.level=UnitLevel("player")
        self.db.account.Characters[UnitName("player")]=char
    end
end

function RootsBidder:OnCommReceive(prefix, sender, distribution, command, arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11)
	if command == "OB" then
        RootsBidder:doOpenBid(arg0,arg1)
	elseif command =="BB" then
        RootsBidder:AcceptBid(arg0,arg1,arg2,arg3)
    elseif command =="CB" then
        RootsBidder:doCancelBid()
    elseif command == "CL" then
        RootsBidder:doCloseBid(arg0)
    elseif command =="VC" then 
        RootsBidder:sendVersion()
    elseif command =="DKP" then 
        RootsBidder:ReceiveDKP(arg0,arg1,arg2)
    elseif command =="OO" then
        self:DoOpenBid(arg0,arg1,arg2,arg3,arg4)
    elseif command =="QM" then
        self:AnswerMain()
    elseif command =="SB" then
        self:StopBidding()
    end  
end


function RootsBidder:SendMessage(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15)
	local sent = self:SendCommMessage("GROUP", p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15)
    if sent == true then
        if RootsTracker ~= nil then 
            RootsTracker:OnCommReceive(self.BidderPrefix, UnitName("player"), "GROUP", p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15)
        end
    end
end

function RootsBidder:GetMainName()
    return self.db.account.MainName
end

function RootsBidder:SetMainName(newValue)
    self.db.account.MainName = newValue
    self:SendMessage("CM",newValue)
end

function RootsBidder:UpdateOptionsDKP()
    for dkp in pairs(self.db.account.DKP) do
        local opt = {}
        opt.type='execute'
        opt.name= dkp
        opt.desc="Shows the " .. dkp.." Value on the Fubar"
        opt.func= function() self.db.account.displayOnFubar = dkp RootsBidder:OnTextUpdate() end
        options.args["SHOW"].args[dkp]=opt
    end
end

function RootsBidder:UpdateMain()
    for char in pairs(self.db.account.Characters) do
        local opt= {}
        opt.type='execute'
        opt.name= char
        opt.desc= "Set this Character as your main."
        opt.func= function () self.db.account.MainName=char self:Print("Main has been set to: " ..char) self:SendMessage("CM",char) end
        options.args["Main"].args[char]=opt
    end
end

function RootsBidder:AnswerMain()
    self:SendMessage("CM",self.db.account.MainName)
end

function RootsBidder:StopBidding(line)
    self.LootList ={}
    if self.GUI.bids ~= nil then
        for counter in pairs(self.GUI.bids) do
            self:ResetBidLine(counter)
        end
    end
end

